var language='cn';
var SetserviceUUID_index=3;     //测试模块为1  公司模块3
var SetcharacteristicUUID_index=5;   //测试模块为0  公司模块5
var Setnotify_index=5;               //测试模块为1  公司模块5

//判断是否为空对象
function isEmpty(obj)
{
for (var name in obj)
{
return false;
}
return true;
};

//16进制符串转数组
function StrtoArr(str)

{

    var pos = 0;

    var len = str.length;

    if(len %2 != 0)

    {

       return null;

    }

    len /= 2;

    var hexA = new Array();

    for(var i=0; i<len; i++)

    {

       var s = str.substr(pos, 2);

       //var v = parseInt(s, 16);

       hexA.push(s);

       pos += 2;

    }

    return hexA;

}

//蓝牙操作
var UILoadingid;
var serviceUUID, peripheralUUID,peripheralUUID_buk, characteristicUUID,isone;

    function findble() {
        var ble = api.require('ble');
        language=api.getPrefs({
                sync: true,
                key: 'language'
            });

        ble.initManager(function(ret) {
            if (ret.state == "poweredOn") {
                var peripherals = api.getPrefs({
                      sync: true,
                      key: 'peripherals'
                  });
                  ble.isConnected({
                      peripheralUUID: peripherals
                  }, function(ret) {
                          if (ret.status) {
                            ble.disconnect({
                            peripheralUUID: peripherals
                            });
                          }
                  });
                ble.scan({
                    //  serviceUUIDS : scandev
                }, function(ret) {
                    if (ret.status) {
                        alert('扫描结果状态：' + JSON.stringify(ret));
                        setTimeout("ble_getPeripheral()", 3000);
                        UILoading = api.require('UILoading');
                        UILoading.flower({
                            size: 80,
                            fixed: true
                        }, function(ret) {
                            UILoadingid = ret.id;
                        });
                    }
                });
            }else {
              if (language=='cn') {
                alert('请手动打开蓝牙');
              } else {
                alert('Please open the bluetooth manually');
              }

            };
        });
    };



    function ble_getPeripheral() {
        var ble = api.require('ble');
        ble.getPeripheral(function(ret) {
          alert('蓝牙设备：' + JSON.stringify(ret));
          //var systemType = api.systemType;  // 比如： ios  这个则么判断是否是ios呢？
          // console.log(systemType);
            if (!isEmpty(ret.peripherals)) {
              //ios的不可以停止扫描
              //ble.stopScan();
              peripheralUUID = ret;
              isone=0;
            } else {
              // $api.byId('blelist').innerHTML = '没有找到可用的蓝牙设置';
                if (language=='cn') {
                  alert('没有找到可用的蓝牙设置');
                } else {
                  alert('Could not find the available bluetooth device');
                }
            }
            //更新UI,发送监听事件
            api.sendEvent({
            name: 'upUI',
            extra: {
                dev: ret
            }
        });
        });
        var uiloading = api.require('UILoading');
        uiloading.closeFlower({
            id: UILoadingid
        });

    }
//连接蓝牙
    var isconn=0; //重连次数
    var xindex=0;
    function bleconnect(index,uuid) {
      var ble = api.require('ble');
      xindex=index;
      peripheralUUID=uuid;
      //alert("连接硬件："+JSON.stringify(peripheralUUID));
      UILoading = api.require('UILoading');
      UILoading.flower({
          size: 80,
          fixed: true
      }, function(ret) {
          UILoadingid = ret.id;
      });

        ble.connect({
            peripheralUUID: peripheralUUID
        }, function(ret, err) {
            if (ret.status) {
                if (language=='cn') {
                  api.toast({
                      msg: '连接成功！',
                      duration: 2000,
                      location: 'bottom'
                  });
                } else {
                    api.toast({
                        msg: 'The connection is successful',
                        duration: 2000,
                        location: 'bottom'
                    });

                   }
                ble_discoverService();  //发现服务

                api.setPrefs({
                    key: 'peripherals',
                    value: peripheralUUID
                });
                //停止扫描
                //ble.stopScan();

                api.sendEvent({
                name: 'upConnUI',
                extra: {
                    key: xindex,
                    status:1
                }
            });

                var uiloading = api.require('UILoading');
                uiloading.closeFlower({
                    id: UILoadingid
                });
            } else {
              //alert("连接次数："+isconn);
              if (isconn<=2) {
              bleconnect(index,uuid);
              isconn=isconn+1;
              var uiloading = api.require('UILoading');
              uiloading.closeFlower({
                  id: UILoadingid
              });
              return;
            }

            api.removePrefs({
                key: 'peripherals'
            });

                if (language=='cn') {
                //  alert('已连接3次失败，请检查硬件');
                  api.toast({
                      msg: '已连接3次失败，请检查硬件',
                      duration: 2000,
                      location: 'bottom'
                  });
                   //alert('连接错误信息：'+JSON.stringify(err));
                  } else {
                //  alert('The connection fails');
                  api.toast({
                      msg: 'The connection fails',
                      duration: 2000,
                      location: 'bottom'
                  });
         }
         api.sendEvent({
         name: 'upConnUI',
         extra: {
             key: xindex,
             status:0
         }
       });
         var uiloading = api.require('UILoading');
         uiloading.closeFlower({
             id: UILoadingid
         });

            }

        });

    }

    //发现服务
function ble_discoverService() {
    //根据指定的外围设备 UUID 获取该外围设备的所有服务
    var ble = api.require('ble');
      //alert('获取该外围设备的所有服务' + JSON.stringify(peripheralUUID));
    ble.discoverService({
            peripheralUUID: peripheralUUID
        }, function(ret, err) {
            alert('根据指定的外围设备 UUID 获取该外围设备的所有服务' + JSON.stringify(ret));
            if (ret.status) {
                 serviceUUID = ret.services;
              //  alert('根据指定的外围设备 UUID 获取该外围设备的所有服务' + JSON.stringify(serviceUUID));
                var systemType = api.systemType;  // 比如： ios  这个则么判断是否是ios呢？
                if (systemType=='ios') {
                  serviceUUID = serviceUUID[0];
                } else {
                  serviceUUID = serviceUUID[SetserviceUUID_index]; //测试模块为1  公司模块3
                }
              //  alert('获取UUID:'+JSON.stringify(serviceUUID));
                discoverCharacteristics(peripheralUUID, serviceUUID);
            } else {
                if (language=='cn') {
                alert('获取服务UUID失败！' + err.code + ':' + err.msg);
                  } else {
                alert('Failed to get serviceUUID');
         }
            }

        }

    );
}


      //7根据指定的外围设备 UUID 及其服务 UUID 获取该外围设备的所有特征（Characteristic）
function discoverCharacteristics(peripheralUUID, serviceUUID) {
    var ble = api.require('ble');
        if (serviceUUID && peripheralUUID) {
            ble.discoverCharacteristics({
                serviceUUID: serviceUUID,
                peripheralUUID: peripheralUUID
            }, function(ret, err) {
                //alert('获取该外围设备的所有特征' + JSON.stringify(ret));
                if (ret.status) {

                  //跳转页面
                  api.setFrameGroupIndex({
                      name: 'group',
                      index: 1
                  });
                      //运行父窗口的方法
                  api.execScript({
                  name: 'root',
                  script: 'setAct(1)'
              });
                    characteristicUUID = ret.characteristics[SetcharacteristicUUID_index].uuid;   //测试模块为0  公司模块5
                    //读取电压与设置
                  //  alert('发送命令：FAAB00000000000000000000000000');
                    //blesend('FAAB00000000000000000000000000');
                    setTimeout("blesend('FAAB00000000000000000000000000')",1000);
                    //alert('连接特征characteristics：' + JSON.stringify(characteristicUUID));
                    //alert('连接buk：' + JSON.stringify(peripheralUUID_buk));
                    //监听接收数据
                    ble.setNotify({
                        peripheralUUID:peripheralUUID,
                        serviceUUID:serviceUUID,
                        characteristicUUID:ret.characteristics[Setnotify_index].uuid  //测试模块为3  公司模块5
                    }, function(ret) {
                      //api.alert(JSON.stringify(ret));
                        if (ret.status) {
                            api.alert({ msg:'收到信息：'+ JSON.stringify(ret.characteristic.value) });
                            //收到硬件发来的信息做相应处理，然后发送监听事件
                            var SMSstyle=StrtoArr(ret.characteristic.value);
                            //api.alert({ msg:'收到信息：'+ SMSstyle});
                            if (SMSstyle.length==3) {
                              casedat=SMSstyle[0]+SMSstyle[1]+SMSstyle[2];
                              //alert(casedat);
                              switch (casedat) {
                                case 'aa00ff':
                                  if (language=='cn') {
                                    api.toast({
                                        msg: '写入数据成功',
                                        duration: 2000,
                                        location: 'bottom'
                                    });                } else {
                                      api.toast({
                                          msg: 'Write data successfully',
                                          duration: 2000,
                                          location: 'bottom'
                                      });                }
                                  break;
                                  case 'aa0000':
                                    if (language=='cn') {
                                      api.toast({
                                          msg: '写入数据失败',
                                          duration: 2000,
                                          location: 'bottom'
                                      });                } else {
                                        api.toast({
                                            msg: 'Write data failure',
                                            duration: 2000,
                                            location: 'bottom'
                                        });                }
                                    break;
                                    case 'faab00':
                                      if (language=='cn') {
                                        api.toast({
                                            msg: '失败拒绝访问或未知错误',
                                            duration: 2000,
                                            location: 'bottom'
                                        });                } else {
                                          api.toast({
                                              msg: 'Failure to deny access or unknown error',
                                              duration: 2000,
                                              location: 'bottom'
                                          });                }
                                      break;
                                      case 'fabbff':
                                        if (language=='cn') {
                                          api.toast({
                                              msg: '发送成功',
                                              duration: 2000,
                                              location: 'bottom'
                                          });                } else {
                                            api.toast({
                                                msg: 'send successful',
                                                duration: 2000,
                                                location: 'bottom'
                                            });                }
                                        break;
                                        case 'fabb0':
                                          if (language=='cn') {
                                            api.toast({
                                                msg: '发送失败',
                                                duration: 2000,
                                                location: 'bottom'
                                            });                } else {
                                              api.toast({
                                                  msg: 'send failure',
                                                  duration: 2000,
                                                  location: 'bottom'
                                              });                }
                                          break;

                                default:

                              }
                            }

                            if (SMSstyle.length>3) {
                              casedat=SMSstyle[0]+SMSstyle[1];
                            //  alert(casedat);
                            //  alert(SMSstyle);
                              switch (casedat) {
                                case 'aa01':
                                //发送监听事件
                                api.sendEvent({
                                    name: 'com_aa',
                                    extra: {
                                  value: ret.characteristic.value,
                                  }
                                });
                                  break;
                                case 'faff':
                                //发送监听事件
                                api.sendEvent({
                                    name: 'com_fa',
                                    extra: {
                                  value: ret.characteristic.value,
                                  }
                                });
                                  break;
                                default:
                                case 'faab':
                                //发送监听事件
                                api.sendEvent({
                                    name: 'com_faup',
                                    extra: {
                                  value: ret.characteristic.value,
                                  }
                                });
                                  break;
                              }
                            }else {
                              if (SMSstyle[0]=='ef') {
                              //电压
                                  api.sendEvent({
                                      name: 'upvol',
                                      extra: {
                                    vol:parseInt(SMSstyle[1],16)/10,
                                    }
                                  });
                              }
                            }

                        }
                    });
                } else {
                    if (language=='cn') {
                    alert('获取设备特征失败！' + err.code + ':' + err.msg);
                      } else {
                    alert('Failed to get equipment features');
             }
                }


            });
        } else {
          //  alert(JSON.stringify(serviceUUID));
          //  alert(JSON.stringify(peripheralUUID));
            if (language=='cn') {
            alert('设备uuid或serviceUUID不能为空' + err.code + ':' + err.msg);
              } else {
            alert('Device uuid or serviceUUID cannot be empty');
     }
            return false;
        }
    }


    function blesend(data) {
    var ble = api.require('ble');
    ble.writeValueForCharacteristic({
        peripheralUUID: peripheralUUID,
        serviceUUID: serviceUUID,
        characteristicUUID: characteristicUUID,
        value: data, //此处是我向蓝牙设备发送指令获取设备时间
        writeType: 'withoutResponse'
    }, function(ret, err) {
        //  api.alert({ msg: JSON.stringify(ret) });
        //  api.alert({ msg: JSON.stringify(err) });
        // ble.readValueForCharacteristic(peripheralUUID,serviceUUID,characteristicUUID);
        //alert('写数据返回内容:' + JSON.stringify(ret)+"错误信息"+ JSON.stringify(err));
        /*
        if (ret.status) {
            //alert('send ok');
        } else {
            if (language=='cn') {
            //  alert('发送失败，错误码：' + err.code);
              } else {
            //  alert('Send failure, error code：' + err.code);
     }
        }
        */
    });
    }

function k_blesend(data) {
    // api.toast({
    //     msg: '发送命令：'+data,
    //     duration: 8000,
    // });
  //alert('发送命令：'+StrtoArr(data));
  api.execScript({
  name: 'root',
  script:  'blesend("' + data + '")' //  script: 'setData("' + id + '","' + name + '");'
});
}
